
import java.util.HashMap;

public class NLInfixfunc extends NLTerm {

// ----------------------------------------------------------------------------
// Data
// ----------------------------------------------------------------------------
  
  NLTerm T;
  String s, aString = "", bString = "";
  boolean isInWords = false;
  String translation = "";
  
  static final int DEFAULT = 1;
  static final int WORDS = 2;
  
  boolean diag = false;
  
// ----------------------------------------------------------------------------
// Constructors
// ----------------------------------------------------------------------------

  public NLInfixfunc(NLTerm T, String s) {
    this.T = T; this.s = s;
  }

// ----------------------------------------------------------------------------
// Methods
// ----------------------------------------------------------------------------
  
  public String getPrecedence() {
    String prec = "infinity";
    if (s!=null) {
      MathDefDictionary mdd = new MathDefDictionary();
      prec = mdd.lookUpInfixPrecedence(s);
    }
    return prec;
  }
  
  public void setArgStrings(String a, String b) {
    aString = a; bString = b;
  }
  
  public String xlat(int code) {
    String x = "";
    if (s!=null) {
      HashMap map = NLLookup.lookUp(s,"infix");
      String phrase = getPhrase(code,map);
      //diag:
      if (false) {
        System.out.println(
          (String) map.get("symb") + "\n" +
          (String) map.get("word")
        );
      }
      //
      if (phrase==null) {
        s = Evaluable.ddStrip(s);
        x = "$"+s+"$";
      } else {
        String[] d = {aString,bString};
        NLPhraseEvaluator ev = new NLPhraseEvaluator(phrase);
        x = ev.eval(d);
      }
    } else {
      x = T.xlat(code);
    }
    this.translation = x;
    return x;
  }
  
  public boolean isInWords() {
  //Should call xlat before this method.
    return isInWords;
  }

  public String getString() {
  //Should call xlat before this method.
    return translation;
  }

  String getPhrase(int code, HashMap map) {
    String phrase = "";
    //First determine if there is a symbolic phrase available.
    boolean symbolsAvailable = false;
    phrase = (String) map.get(GrammarConstants.FUNCSYMB);
    symbolsAvailable = (phrase!=null);
    //At this point phrase is already set up, provided we want
    //symbols.
    if ((code&WORDS)!=0 || !symbolsAvailable) {
    //We want words.
      phrase = (String) map.get(GrammarConstants.FUNCWORD);
      this.isInWords = true;
    }
    return phrase;
  }

// ----------------------------------------------------------------------------
}  // ----------------------------------------------------------------------
// ---------------------------------------------------------------------------- 
