 

public class NLOnetrue extends NLFormula {
  
  boolean asserted;
  NLFormula[] ff;
  
  boolean isInWords = false;
  String translation = "";
    
  public NLOnetrue(boolean asserted, NLFormula[] ff) {
    this.asserted = asserted; this.ff = ff;
  }
  
  public String xlat(int mode) {
    //First call the xlat methods of the children, and figure out
    //if we are forced to return words.
    for (NLFormula form : ff) {
      form.xlat(mode); this.isInWords |= form.isInWords();
    }
    //Finally, write the string.
    String x = "";
    if (this.isInWords || mode==NLPhrase.WORDS_MODE) {
      x = writeWords();
    } else {
      x = writeSymbols();
    }
    this.translation = x;
    return x;
  }
  
  public boolean isInWords() {
  //Should be called only *after* xlat.
    return this.isInWords;
  }

  public String getString() {
  //Should be called only *after* xlat.
    return this.translation;
  }
   
  String writeSymbols() {
    String s = "";
      s += (asserted?"":"\\neg ");
      s += "![";
      for (int i = 0; i < ff.length; i++) {
        s += (i>0?",":"")+ff[i].getString();
      }
      s += "]";
    return s;
  }
  
  String writeWords() {    
    String s = "";
      s += (asserted?"":"it is not the case that ");
      s += "precisely one of the following is true:\n";
      s += "\\begin{enumerate}\n";
      for (NLFormula form : ff) {
        s += "\\item "+form.getString()+"\n";
      }
      s += "\\end{enumerate}";
    return s;
  }
 
}
