/* Generated By:JavaCC: Do not edit this line. PST2NL.java */
import java.io.*;
import java.util.Vector;
import java.util.regex.*;

public class PST2NL implements PST2NLConstants {

  //The user should pass to the constructor the File containing the
  //formulas and definitions to be translated.
  //Then call the init() method.
  //Finally, invoke the appropriate parse method:
  //either the parseFormula or the parseDef method, or the
  //parseList method. The latter is also invoked from the main method.

  static String texhead = "\\documentclass{report}\n\n"+
                      "\\usepackage{amssymb, amsfonts, mathrsfs, steve}\n\n"+
                      "\\begin{document}\n\n";
  static String texfoot = "\n\\end{document}";

  public static void main(String[] args) {
    String f;
    String o;
    boolean tw;
    boolean bs;
    //If you just want to open a bracketed file from the usual directory,
    //and process it and save the output in the tex directory, with the
    //.br replaced by .tex, then pass a single argument on the command line,
    //namely, the part of the name without the .br.
    if (args.length==1) {
      NLLookup.init();
      String name = args[0];
      f = "../pstparse/pstoutput/"+name+".br";
      o = "../tex/"+name+".tex";
      tw = true; bs = true;
    } else {
    //Otherwise we prompt you for the file names, etc.
    //Here you have to supply the directories and extensions yourself.
      NLLookup.init();
      Console c = System.console();
      if (c==null) {
        System.err.println("No console.");
        System.exit(1);
      }
      f = c.readLine("Input file: ");
      o = c.readLine("Output file: ");
      tw = c.readLine("TeX wrapper? [y/n] ").equals("y");
      bs = c.readLine("Big skips? [y/n] ").equals("y");
    }
    try {
      FileInputStream in = new FileInputStream(f);
      FileOutputStream out = new FileOutputStream(o);
      PST2NL parser = new PST2NL(in);
      parser.parseList(out,tw,bs);
    } catch (IOException e) {e.printStackTrace();}
  }

  public static void init() {
    NLLookup.init();
  }

  public static String parseFormula() {
    String s = "";
    try {
      s = formula(true,true).xlat(NLPhrase.DEFAULT_MODE);
    } catch (ParseException e) {e.printStackTrace();}
    return s;
  }

  public static String parseDef() {
    String s = "";
    try {
      s = definition();
    } catch (ParseException e) {e.printStackTrace();}
    return s;
  }

  public static void parseList(FileOutputStream out,
                               boolean tw, boolean bs) {
    try {
      if (tw) {out.write(texhead.getBytes());}
      list(out,bs);
      if (tw) {out.write(texfoot.getBytes());}
    } catch (Exception e) {e.printStackTrace();}
  }

  public static String initCap(String r) {
    if (startsWithLowercase(r)) {
      r = r.substring(0,1).toUpperCase()+
          r.substring(1,r.length());
    } else if (startsWithEmphLowercase(r)) {
      r = r.substring(0,6)+
          r.substring(6,7).toUpperCase()+
          r.substring(7,r.length());
    }
    return r;
  }

  public static boolean startsWithNumber(String r) {
    boolean b = false;
    if (r!=null && r.length() > 0) {
      char c = r.charAt(0);
      byte cb = (byte) c;
      if (48 <= cb && cb <= 57) {b = true;}
    }
    return b;
  }

  public static boolean startsWithLowercase(String r) {
    boolean b = false;
    if (r!=null && r.length() > 0) {
      char c = r.charAt(0);
      byte cb = (byte) c;
      if (97 <= cb && cb <= 122) {b = true;}
    }
    return b;
  }

  public static boolean startsWithEmphLowercase(String r) {
    boolean b = false;
    if (r!=null && r.length() >= 7) {
      String emph = r.substring(0,6);
      char c = r.charAt(6);
      byte cb = (byte) c;
      if (emph.equals("\\emph{") && (97 <= cb) && (cb <= 122)) {b = true;}
    }
    return b;
  }

  public static int firstNumericIndex(String r) {
    Pattern pattern = Pattern.compile("(\\s|\\{)([0-9])");
    Matcher matcher = pattern.matcher(r);
    int z = -1;
    if (matcher.find()) {
      z = matcher.start(2);
    }
    return z;
  }

  public static int firstAlphaIndex(String r) {
    Pattern pattern = Pattern.compile("(\\s|\\{)([a-zA-Z])");
    Matcher matcher = pattern.matcher(r);
    int z = -1;
    if (matcher.find()) {
      z = matcher.start(2);
    }
    return z;
  }

  public static int indexOfFirstAlphaRun(String r) {
    Pattern pattern = Pattern.compile("(\\s|\\{)([a-zA-Z]{2,})");
    Matcher matcher = pattern.matcher(r);
    int z = -1;
    if (matcher.find()) {
      z = matcher.start(2);
    }
    return z;
  }

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// Superstructure
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
  static final public void list(FileOutputStream out, boolean bs) throws ParseException {
  String r;
  String sep = "\n\n"+(bs?"\\bigskip\n":"");
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DEFINITION:
      case FORMULA:
        ;
        break;
      default:
        jj_la1[0] = jj_gen;
        break label_1;
      }
      r = item();
      r += sep;
      try {
        out.write(r.getBytes());
      } catch (IOException e) {e.printStackTrace();}
    }
    jj_consume_token(0);
  }

// ------------------------------------------------------------------
  static final public String item() throws ParseException {
  String r;
  NLFormula f;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DEFINITION:
      r = definition();
      break;
    case FORMULA:
      f = formula(true,true);
                             r = f.xlat(NLPhrase.DEFAULT_MODE);
      break;
    default:
      jj_la1[1] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    {if (true) return r;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------------------
  static final public String definition() throws ParseException {
  String s,r;
    jj_consume_token(DEFINITION);
    r = defname();
   s="{\\bf Definition "+r+":} ";
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DEFBODY:
      r = defbody();
      break;
    case INFIXDEFBODY:
      r = infixdefbody();
      break;
    default:
      jj_la1[2] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
   s+=r;
    jj_consume_token(UP);
    {if (true) return s;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public String defname() throws ParseException {
  Token t;
    jj_consume_token(DEFNAME);
    jj_consume_token(TXT);
    t = jj_consume_token(WORD);
    jj_consume_token(UP);
   System.out.println(t.image);
    {if (true) return t.image;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public String defbody() throws ParseException {
  String s="",r;
    jj_consume_token(DEFBODY);
    numeral();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case RSTR:
      r = rstr();
      //{s+="relation "+r+".";}
          r = relndef();
                   s+=r;
      break;
    case FSTR:
      r = fstr();
      //{s+="function "+r+".";}
          r = funcdef();
                   s+=r;
      break;
    default:
      jj_la1[3] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(UP);
   {if (true) return s;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public String infixdefbody() throws ParseException {
  String s="",r;
    jj_consume_token(INFIXDEFBODY);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case RSTR:
      r = rstr();
      //{s+="relation "+r+".";}
          r = infixrelndef();
                        s+=r;
      break;
    case FSTR:
      r = fstr();
      //{s+="function "+r+".";}
          r = infixfuncdef();
                        s+=r;
      break;
    default:
      jj_la1[4] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(UP);
   {if (true) return s;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public String relndef() throws ParseException {
  String s="",r;
  NLFormula f;
    jj_consume_token(RELNDEF);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case RELNDEFUNIT:
      r = relndefunit();
                       s=" "+r+".";
      break;
    case FORMULA:
      label_2:
      while (true) {
        f = formula(true,false);
                              s+=" If "+f.xlat(NLPhrase.DEFAULT_MODE);
        r = relndefunit();
                        s+=" then "+r+".";
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case FORMULA:
          ;
          break;
        default:
          jj_la1[5] = jj_gen;
          break label_2;
        }
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case RELNDEFUNIT:
        r = relndefunit();
                        s+=" Otherwise "+r+".";
        break;
      default:
        jj_la1[6] = jj_gen;
        ;
      }
      break;
    default:
      jj_la1[7] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(UP);
   {if (true) return s;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public String relndefunit() throws ParseException {
  NLRelndefunit unit;
  //NLDefinedConcept nldc;
  String r;
  NLTerm[] vv;
  NLFormula f;
    jj_consume_token(RELNDEFUNIT);
    r = rstr();
    vv = varseq();
    f = formula(true,false);
    jj_consume_token(UP);
    unit = new NLRelndefunit(r,vv,f);
    {if (true) return unit.xlat();}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public String infixrelndef() throws ParseException {
  NLFormula f;
  String s="",r;
    jj_consume_token(INFIXRELNDEF);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INFIXRELNDEFUNIT:
      r = infixrelndefunit();
                            s=" "+r+".";
      break;
    case FORMULA:
      label_3:
      while (true) {
        f = formula(true,false);
                              s+=" If "+f.xlat(NLPhrase.DEFAULT_MODE);
        r = infixrelndefunit();
                             s+=" then "+r+".";
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case FORMULA:
          ;
          break;
        default:
          jj_la1[8] = jj_gen;
          break label_3;
        }
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INFIXRELNDEFUNIT:
        infixrelndefunit();
                         s+=" Otherwise "+r+".";
        break;
      default:
        jj_la1[9] = jj_gen;
        ;
      }
      break;
    default:
      jj_la1[10] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(UP);
    {if (true) return s;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public String infixrelndefunit() throws ParseException {
  NLInfixrelndefunit unit;
  String r;
  NLTerm[] vv = new NLTerm[2];
  NLFormula f;
    jj_consume_token(INFIXRELNDEFUNIT);
    vv[0] = var();
    r = rstr();
    vv[1] = var();
    f = formula(true,false);
    jj_consume_token(UP);
    unit = new NLInfixrelndefunit(vv,r,f);
    {if (true) return unit.xlat();}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public String funcdef() throws ParseException {
  NLFormula f;
  String s="",r;
    jj_consume_token(FUNCDEF);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FUNCDEFUNIT:
      r = funcdefunit();
                       s=" "+initCap(r)+".";
      break;
    case FORMULA:
      label_4:
      while (true) {
        f = formula(true,false);
                              s+=" If "+f.xlat(NLPhrase.DEFAULT_MODE);
        r = funcdefunit();
                        s+=" then "+r+".";
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case FORMULA:
          ;
          break;
        default:
          jj_la1[11] = jj_gen;
          break label_4;
        }
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case FUNCDEFUNIT:
        r = funcdefunit();
                        s+=" Otherwise "+r+".";
        break;
      default:
        jj_la1[12] = jj_gen;
        ;
      }
      break;
    default:
      jj_la1[13] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(UP);
    {if (true) return s;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public String funcdefunit() throws ParseException {
  NLFuncdefunit unit;
  NLTerm s,r=null;
    jj_consume_token(FUNCDEFUNIT);
    s = composite();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TERM:
      r = term();
      break;
    default:
      jj_la1[14] = jj_gen;
      ;
    }
    jj_consume_token(UP);
    unit = new NLFuncdefunit(s,r);
    {if (true) return unit.xlat();}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public String infixfuncdef() throws ParseException {
  NLFormula f;
  String s="",r,p;
    jj_consume_token(INFIXFUNCDEF);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INFIXFUNCDEFUNIT:
      r = infixfuncdefunit();
                            s=" "+r+".";
      p = precedence();
      break;
    case FORMULA:
      label_5:
      while (true) {
        f = formula(true,false);
                              s+=" If "+f.xlat(NLPhrase.DEFAULT_MODE);
        r = infixfuncdefunit();
                             s+=" then "+r+".";
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case FORMULA:
          ;
          break;
        default:
          jj_la1[15] = jj_gen;
          break label_5;
        }
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INFIXFUNCDEFUNIT:
        r = infixfuncdefunit();
                             s+=" Otherwise "+r+".";
        break;
      default:
        jj_la1[16] = jj_gen;
        ;
      }
      p = precedence();
      break;
    default:
      jj_la1[17] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
   s+=" Precedence: "+p+".";
    jj_consume_token(UP);
    {if (true) return s;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public String infixfuncdefunit() throws ParseException {
  NLInfixfuncdefunit unit;
  NLTerm a,b,r=null;
  String s;
    jj_consume_token(INFIXFUNCDEFUNIT);
    a = var();
    s = fstr();
    b = var();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TERM:
      r = term();
      break;
    default:
      jj_la1[18] = jj_gen;
      ;
    }
    jj_consume_token(UP);
    unit = new NLInfixfuncdefunit(a,s,b,r);
    {if (true) return unit.xlat();}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public String precedence() throws ParseException {
  Token t;
    jj_consume_token(PRECEDENCE);
    jj_consume_token(TXT);
    t = jj_consume_token(WORD);
    jj_consume_token(UP);
   {if (true) return t.image;}
    throw new Error("Missing return statement in function");
  }

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// Formulas
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
  static final public NLFormula formula(boolean asserted, boolean main) throws ParseException {
  NLFormula bf, tempf;
  String temp;
  String[] ca = new String[0];
  NLFormula[] bfa = new NLFormula[0];
  NLFormula nlformula;
  Vector lcs = new Vector(), bforms = new Vector();
    jj_consume_token(FORMULA);
    bf = bformula(true);
    label_6:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LC:
        ;
        break;
      default:
        jj_la1[19] = jj_gen;
        break label_6;
      }
      temp = lc();
                 lcs.add(temp);
      tempf = bformula(true);
                            bforms.add(tempf);
    }
    jj_consume_token(UP);
    ca = (String[]) lcs.toArray(ca);
    bfa = (NLFormula[]) bforms.toArray(bfa);
    nlformula = new NLFormula(asserted,main,bf,ca,bfa);
    {if (true) return nlformula;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public NLFormula bformula(boolean asserted) throws ParseException {
  Token t;
  NLFormula s;
    jj_consume_token(BFORMULA);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TXT:
      jj_consume_token(TXT);
      t = jj_consume_token(WORD);
                       s = new NLSymbolFormula(t.image);
      break;
    case TERMFORMULA:
      s = termformula(asserted);
      break;
    case RELATION:
      s = relation(asserted);
      break;
    case FORMULA:
      s = formula(asserted,false);
      break;
    case NEGATION:
      s = negation(asserted);
      break;
    case ONETRUE:
      s = onetrue(asserted);
      break;
    case FORALL:
      s = forall(asserted);
      break;
    case EXISTS:
      s = exists(asserted);
      break;
    case EXISTSUNIQUE:
      s = existsunique(asserted);
      break;
    default:
      jj_la1[20] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(UP);
   {if (true) return s;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public NLTermformula termformula(boolean asserted) throws ParseException {
  NLTermformula nltermformula;
  Token t;
  NLTerm s;
  String d=null;
  NLInfixrel alpha=null;
  NLTerm[] tt=null,uu=null,ww=null;
  NLInfixrel[] aa = new NLInfixrel[0];
  NLTerm[][] ttt = new NLTerm[0][];
  Vector terms = new Vector(), rels = new Vector();
    jj_consume_token(TERMFORMULA);
    s = term();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TXT:
      jj_consume_token(TXT);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case WORD:
        t = jj_consume_token(WORD);
                          d = t.image;
        break;
      case TERMSEQ:
        tt = termseq();
        break;
      default:
        jj_la1[21] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    case INFIXREL:
    case TERMSEQ:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TERMSEQ:
        uu = termseq();
        break;
      default:
        jj_la1[22] = jj_gen;
        ;
      }
      alpha = infixrel();
                         rels.add(alpha);
      ww = termseq();
                     terms.add(ww);
      label_7:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case INFIXREL:
          ;
          break;
        default:
          jj_la1[23] = jj_gen;
          break label_7;
        }
        alpha = infixrel();
                          rels.add(alpha);
        ww = termseq();
                      terms.add(ww);
      }
      break;
    default:
      jj_la1[24] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(UP);
    aa = (NLInfixrel[]) rels.toArray(aa);
    ttt = (NLTerm[][]) terms.toArray(ttt);
    nltermformula = new NLTermformula(asserted,s,d,tt,uu,aa,ttt);
    {if (true) return nltermformula;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public NLFormula negation(boolean asserted) throws ParseException {
  NLFormula s;
    jj_consume_token(NEGATION);
    s = bformula(!asserted);
    jj_consume_token(UP);
    {if (true) return s;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public NLOnetrue onetrue(boolean asserted) throws ParseException {
  NLFormula[] s;
    jj_consume_token(ONETRUE);
    s = formulaseq();
    jj_consume_token(UP);
   {if (true) return new NLOnetrue(asserted,s);}
    throw new Error("Missing return statement in function");
  }

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// Quantifiers
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
  static final public NLQuant forall(boolean asserted) throws ParseException {
  NLQuant nlquant;
  NLInfixrel alpha=null;
  NLFormula rho=null,phi=null,psi=null;
  NLTerm[] tt,uu=null,vv=null;
    jj_consume_token(FORALL);
    tt = termseq();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TXT:
      jj_consume_token(TXT);
      rho = formula(true,false);
      phi = bformula(true);
      break;
    case FORMULA:
    case BFORMULA:
    case INFIXREL:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INFIXREL:
        alpha = infixrel();
        uu = termseq();
        break;
      default:
        jj_la1[25] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BFORMULA:
        phi = bformula(true);
        break;
      case FORMULA:
        psi = formula(true,false);
        vv = varseq();
        break;
      default:
        jj_la1[26] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[27] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(UP);
    nlquant = new NLQuant(asserted,"forall",tt,rho,phi,alpha,uu,psi,vv);
    {if (true) return nlquant;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public NLQuant exists(boolean asserted) throws ParseException {
  NLQuant nlquant;
  NLInfixrel alpha=null;
  NLFormula rho=null,phi=null,psi=null;
  NLTerm[] tt,uu=null,vv=null;
    jj_consume_token(EXISTS);
    tt = termseq();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TXT:
      jj_consume_token(TXT);
      rho = formula(true,false);
      phi = bformula(true);
      break;
    case FORMULA:
    case BFORMULA:
    case INFIXREL:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INFIXREL:
        alpha = infixrel();
        uu = termseq();
        break;
      default:
        jj_la1[28] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BFORMULA:
        phi = bformula(true);
        break;
      case FORMULA:
        psi = formula(true,false);
        vv = varseq();
        break;
      default:
        jj_la1[29] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[30] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(UP);
    nlquant = new NLQuant(asserted,"exists",tt,rho,phi,alpha,uu,psi,vv);
    {if (true) return nlquant;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public NLQuant existsunique(boolean asserted) throws ParseException {
  NLQuant nlquant;
  NLInfixrel alpha=null;
  NLFormula rho=null,phi=null,psi=null;
  NLTerm[] tt,uu=null,vv=null;
    jj_consume_token(EXISTSUNIQUE);
    tt = termseq();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TXT:
      jj_consume_token(TXT);
      rho = formula(true,false);
      phi = bformula(true);
      break;
    case FORMULA:
    case BFORMULA:
    case INFIXREL:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INFIXREL:
        alpha = infixrel();
        uu = termseq();
        break;
      default:
        jj_la1[31] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BFORMULA:
        phi = bformula(true);
        break;
      case FORMULA:
        psi = formula(true,false);
        vv = varseq();
        break;
      default:
        jj_la1[32] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[33] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(UP);
    nlquant = new NLQuant(asserted,"existsUnique",tt,rho,phi,alpha,uu,psi,vv);
    {if (true) return nlquant;}
    throw new Error("Missing return statement in function");
  }

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// Terms
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
  static final public NLTerm term() throws ParseException {
  NLTerm nlterm;
  NLBterm s,t;
  NLInfixfunc alpha;
  NLInfixfunc[] aa = new NLInfixfunc[0];
  NLBterm[] tt = new NLBterm[0];
  Vector inf = new Vector(), nlb = new Vector();
    jj_consume_token(TERM);
    s = bterm();
    label_8:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INFIXFUNC:
        ;
        break;
      default:
        jj_la1[34] = jj_gen;
        break label_8;
      }
      alpha = infixfunc();
                         inf.add(alpha);
      t = bterm();
                 nlb.add(t);
    }
    jj_consume_token(UP);
    aa = (NLInfixfunc[]) inf.toArray(aa);
    tt = (NLBterm[]) nlb.toArray(tt);
    nlterm = new NLTerm(s,aa,tt);
    {if (true) return nlterm;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public NLBterm bterm() throws ParseException {
  NLBterm nlbterm;
  NLTerm s;
  NLTerm[] tt;
  NLTerm[][] ttt = new NLTerm[0][];
  Vector v = new Vector();
    jj_consume_token(BTERM);
    s = aterm();
    label_9:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EVALUATION:
        ;
        break;
      default:
        jj_la1[35] = jj_gen;
        break label_9;
      }
      tt = evaluation();
                      v.add(tt);
    }
    jj_consume_token(UP);
    ttt = (NLTerm[][]) v.toArray(ttt);
    nlbterm = new NLBterm(s,ttt);
    {if (true) return nlbterm;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public NLTerm aterm() throws ParseException {
  NLTerm s;
    jj_consume_token(ATERM);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case VAR:
      s = var();
      break;
    case NUMERAL:
      s = numeral();
      break;
    case COMPOSITE:
      s = composite();
      break;
    case TERM:
      s = term();
      break;
    case SET:
      s = set();
      break;
    case TUPLE:
      s = tuple();
      break;
    case UNIQUE:
      s = unique();
      break;
    case LAMBDA:
      s = lambda();
      break;
    default:
      jj_la1[36] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(UP);
   {if (true) return s;}
    throw new Error("Missing return statement in function");
  }

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// Term builders
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
  static final public NLLambda lambda() throws ParseException {
  NLLambda nllambda;
  NLInfixrel alpha=null;
  NLFormula phi=null;
  NLTerm t;
  NLTerm[] vv;
  NLTerm[] tt = null;
    jj_consume_token(LAMBDA);
    vv = varseq();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INFIXREL:
      alpha = infixrel();
      tt = termseq();
      break;
    default:
      jj_la1[37] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FORMULA:
      phi = formula(true,false);
      break;
    default:
      jj_la1[38] = jj_gen;
      ;
    }
    t = bterm();
    jj_consume_token(UP);
    nllambda = new NLLambda(vv,alpha,tt,phi,t);
    {if (true) return nllambda;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public NLSet set() throws ParseException {
  NLSet nlset;
  NLTerm s;
  NLInfixrel alpha=null;
  NLFormula psi=null;
  NLTerm[] tt=null,uu=null;
  NLTerm[] vv=null;
    jj_consume_token(SET);
    s = term();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TXT:
    case TERMSEQ:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TERMSEQ:
        tt = termseq();
        break;
      default:
        jj_la1[39] = jj_gen;
        ;
      }
      jj_consume_token(TXT);
      break;
    case FORMULA:
    case INFIXREL:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INFIXREL:
        alpha = infixrel();
        uu = termseq();
        break;
      default:
        jj_la1[40] = jj_gen;
        ;
      }
      psi = formula(true,false);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case VARSEQ:
        vv = varseq();
        break;
      default:
        jj_la1[41] = jj_gen;
        ;
      }
      break;
    default:
      jj_la1[42] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(UP);
    nlset = new NLSet(s,tt,alpha,uu,psi,vv);
    {if (true) return nlset;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public NLUnique unique() throws ParseException {
  NLUnique nlunique;
  NLTerm s;
  NLInfixrel alpha=null;
  NLFormula phi=null,psi=null;
  NLTerm[] tt = null;
  NLTerm[] vv=null;
    jj_consume_token(UNIQUE);
    s = term();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INFIXREL:
      alpha = infixrel();
      tt = termseq();
      break;
    default:
      jj_la1[43] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BFORMULA:
      phi = bformula(true);
      break;
    case FORMULA:
      psi = formula(true,false);
      vv = varseq();
      break;
    default:
      jj_la1[44] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(UP);
    nlunique = new NLUnique(s,alpha,tt,phi,psi,vv);
    {if (true) return nlunique;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public NLTuple tuple() throws ParseException {
  NLTuple nltuple;
  NLTerm[] a;
    jj_consume_token(TUPLE);
    a = termseq();
    jj_consume_token(UP);
    nltuple = new NLTuple(a);
    {if (true) return nltuple;}
    throw new Error("Missing return statement in function");
  }

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// Sequences
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
  static final public NLFormula[] formulaseq() throws ParseException {
  NLFormula s;
  NLFormula[] a = new NLFormula[0];
  Vector v = new Vector();
    jj_consume_token(FORMULASEQ);
    s = formula(true,false);
                           v.add(s);
    label_10:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case FORMULA:
        ;
        break;
      default:
        jj_la1[45] = jj_gen;
        break label_10;
      }
      s = formula(true,false);
                             v.add(s);
    }
    jj_consume_token(UP);
    a = (NLFormula[]) v.toArray(a);
    {if (true) return a;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public NLTerm[] termseq() throws ParseException {
  Vector a = new Vector();
  NLTerm s;
  NLTerm[] b = new NLTerm[0];
    jj_consume_token(TERMSEQ);
    s = term();
              a.add(s);
    label_11:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TERM:
        ;
        break;
      default:
        jj_la1[46] = jj_gen;
        break label_11;
      }
      s = term();
                a.add(s);
    }
    jj_consume_token(UP);
    b = (NLTerm[]) a.toArray(b);
    {if (true) return b;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public NLTerm[] varseq() throws ParseException {
  NLTerm s;
  NLTerm[] ss = new NLTerm[0];
  Vector v = new Vector();
    jj_consume_token(VARSEQ);
    s = var();
             v.add(s);
    label_12:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case VAR:
        ;
        break;
      default:
        jj_la1[47] = jj_gen;
        break label_12;
      }
      s = var();
               v.add(s);
    }
    jj_consume_token(UP);
    ss = (NLTerm[]) v.toArray(ss);
    {if (true) return ss;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public NLTerm[] evaluation() throws ParseException {
  NLTerm[] a;
    jj_consume_token(EVALUATION);
    a = termseq();
    jj_consume_token(UP);
   {if (true) return a;}
    throw new Error("Missing return statement in function");
  }

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// Phrasebook readers
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
  static final public NLComposite composite() throws ParseException {
  String s;
  NLTerm[] tt=null;
    jj_consume_token(COMPOSITE);
    s = fstr();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case EVALUATION:
      tt = evaluation();
      break;
    default:
      jj_la1[48] = jj_gen;
      ;
    }
    jj_consume_token(UP);
    {if (true) return new NLComposite(s,tt);}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public NLInfixfunc infixfunc() throws ParseException {
  NLInfixfunc nlinfixfunc;
  String s = null;
  NLTerm T = null;
    jj_consume_token(INFIXFUNC);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FSTR:
      s = fstr();
      break;
    case TERM:
      T = term();
      break;
    default:
      jj_la1[49] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(UP);
    nlinfixfunc = new NLInfixfunc(T,s);
    {if (true) return nlinfixfunc;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public NLRelation relation(boolean asserted) throws ParseException {
  String s;
  NLTerm[] tt;
    jj_consume_token(RELATION);
    s = rstr();
    tt = termseq();
    jj_consume_token(UP);
    {if (true) return new NLRelation(asserted,s,tt);}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public NLInfixrel infixrel() throws ParseException {
  NLInfixrel nlinfixrel;
  Token t;
  String s = null;
  NLTerm T = null;
    jj_consume_token(INFIXREL);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case RSTR:
      s = rstr();
      break;
    case TXT:
      jj_consume_token(TXT);
      t = jj_consume_token(WORD);
                       s = t.image;
      break;
    case TERM:
      T = term();
      break;
    default:
      jj_la1[50] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(UP);
    nlinfixrel = new NLInfixrel(T,s);
    {if (true) return nlinfixrel;}
    throw new Error("Missing return statement in function");
  }

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// Leaves
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
  static final public String lc() throws ParseException {
  Token t;
    jj_consume_token(LC);
    jj_consume_token(TXT);
    t = jj_consume_token(WORD);
    jj_consume_token(UP);
   {if (true) return t.image;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public NLVar var() throws ParseException {
  Token t;
    jj_consume_token(VAR);
    jj_consume_token(TXT);
    t = jj_consume_token(WORD);
    jj_consume_token(UP);
    {if (true) return new NLVar("$"+t.image+"$");}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public String fstr() throws ParseException {
  Token t;
    jj_consume_token(FSTR);
    jj_consume_token(TXT);
    t = jj_consume_token(WORD);
    jj_consume_token(UP);
    {if (true) return t.image;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public String rstr() throws ParseException {
  Token t;
    jj_consume_token(RSTR);
    jj_consume_token(TXT);
    t = jj_consume_token(WORD);
    jj_consume_token(UP);
    {if (true) return t.image;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public NLNumeral numeral() throws ParseException {
  Token t;
    jj_consume_token(NUMERAL);
    jj_consume_token(TXT);
    t = jj_consume_token(WORD);
    jj_consume_token(UP);
    {if (true) return new NLNumeral(t.image);}
    throw new Error("Missing return statement in function");
  }

  static private boolean jj_initialized_once = false;
  static public PST2NLTokenManager token_source;
  static SimpleCharStream jj_input_stream;
  static public Token token, jj_nt;
  static private int jj_ntk;
  static private int jj_gen;
  static final private int[] jj_la1 = new int[51];
  static private int[] jj_la1_0;
  static private int[] jj_la1_1;
  static {
      jj_la1_0();
      jj_la1_1();
   }
   private static void jj_la1_0() {
      jj_la1_0 = new int[] {0x100080,0x100080,0x600,0x0,0x0,0x100000,0x1000,0x101000,0x100000,0x4000,0x104000,0x100000,0x10000,0x110000,0x80000000,0x100000,0x40000,0x140000,0x80000000,0x200000,0x77900020,0x0,0x0,0x0,0x20,0x0,0x500000,0x500020,0x0,0x500000,0x500020,0x0,0x500000,0x500020,0x0,0x0,0x80000000,0x0,0x100000,0x0,0x0,0x0,0x100020,0x0,0x500000,0x100000,0x80000000,0x0,0x0,0x80000000,0x80000020,};
   }
   private static void jj_la1_1() {
      jj_la1_1 = new int[] {0x0,0x0,0x0,0x6000,0x6000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x10800,0x800,0x400,0xc00,0x400,0x0,0x400,0x400,0x0,0x400,0x400,0x0,0x400,0x200,0x100,0x90f8,0x400,0x0,0x800,0x400,0x4,0xc00,0x400,0x0,0x0,0x0,0x1000,0x100,0x2000,0x4000,};
   }

  public PST2NL(java.io.InputStream stream) {
     this(stream, null);
  }
  public PST2NL(java.io.InputStream stream, String encoding) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    try { jj_input_stream = new SimpleCharStream(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source = new PST2NLTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 51; i++) jj_la1[i] = -1;
  }

  static public void ReInit(java.io.InputStream stream) {
     ReInit(stream, null);
  }
  static public void ReInit(java.io.InputStream stream, String encoding) {
    try { jj_input_stream.ReInit(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 51; i++) jj_la1[i] = -1;
  }

  public PST2NL(java.io.Reader stream) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new PST2NLTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 51; i++) jj_la1[i] = -1;
  }

  static public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 51; i++) jj_la1[i] = -1;
  }

  public PST2NL(PST2NLTokenManager tm) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 51; i++) jj_la1[i] = -1;
  }

  public void ReInit(PST2NLTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 51; i++) jj_la1[i] = -1;
  }

  static final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  static final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  static final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  static final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  static private java.util.Vector jj_expentries = new java.util.Vector();
  static private int[] jj_expentry;
  static private int jj_kind = -1;

  static public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[49];
    for (int i = 0; i < 49; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 51; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 49; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  static final public void enable_tracing() {
  }

  static final public void disable_tracing() {
  }

}
